clear
clf
smt_init

load -mat mcphedran.gd

lambda = 1.45e-6;
k0 = 2*pi/lambda;
positions = distribute(oGd);

Neff = (1.44539); % the fundamental mode
[error, solution] = smt_solve(Neff, oGd, positions, k0);
error
points = 50;
Dx = 1e-5;
Dy = 1e-5;
x = linspace(-Dx, Dx, points);
y = linspace(-Dy, Dy, points);
[neff_i, Sz] = calc_att(solution, positions, oGd, k0, Neff, x, y);
neff_i
imagesc(x, y, abs(Sz))
axis image
colorbar
draw_geom(oGd, 'noaxischange')
colormap pink