clear
oGd.nSources = 50;
oGd.nTestingPoints = round(oGd.nSources*1.3);
oGd.alphaIn = 0.5;
oGd.alphaOut = 0.9;
R = 1; % Radius [m] 
d = 2.1; % Distance between centers

curveArray1 = primitive('circle', R);
curveArray1.xc = -d/2;
curveArray2 = primitive('circle', R);
curveArray2.xc = d/2;
curveArray = array_cat(curveArray1, curveArray2);

oGd.curveArray = curveArray;
oGd.sdArray = compute_sd_array(curveArray);
oGd.nSd = length(oGd.sdArray);
vEr = [1 1.5 1.5].^2;
for iSd = 1:oGd.nSd
    oGd.sdArray(iSd).Er = vEr(iSd);
end
oGd.offsetX = 0;
oGd.offsetY = 0;
save two_fibers.gd oGd
