function vStatus = get_status
global server_names server_con server_ports
vStatus = zeros(1,length(server_con));
for ind = 1:length(server_con)
    stat = pnet_remote(server_con(ind), 'status');
    if isempty(stat)
        vStatus(ind) = -1;
        continue;
    end
    switch stat
        case 'busy'
            vStatus(ind) = 1;
        case 'error'
            vStatus(ind) = -1;
    end
end
